"use strict";
var AuthConfig = (function () {
    function AuthConfig(config) {
        var _this = this;
        this.config = config || {};
        this.headerName = this.config.headerName || 'Authorization';
        this.headerPrefix = !!this.config.headerPrefix ? this.config.headerPrefix + ' ' : 'Bearer ';
        this.tokenName = this.config.tokenName || 'auth_token';
        this.noJwtError = this.config.noJwtError || false;
        this.tokenGetter = this.config.tokenGetter || (function () { return localStorage.getItem(_this.tokenName); });
    }
    AuthConfig.prototype.getConfig = function () {
        return {
            headerName: this.headerName,
            headerPrefix: this.headerPrefix,
            tokenName: this.tokenName,
            tokenGetter: this.tokenGetter,
            noJwtError: this.noJwtError
        };
    };
    return AuthConfig;
}());
exports.AuthConfig = AuthConfig;
//# sourceMappingURL=authconfig.js.map